import 'package:flutter/material.dart';

class ZIMKitMessagePointer extends StatelessWidget {
  final bool isMine;

  const ZIMKitMessagePointer({
    Key? key,
    required this.isMine,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
      padding: EdgeInsets.only(
        left: isMine ? 0 : 5,
        top: 0,
        right: isMine ? 5 : 0,
        bottom: 0,
      ),
      width: 5 + 5,
      height: 10,
      child: CustomPaint(
        painter: ZIMKitMessageTrianglePainter(
          color: Theme.of(context).primaryColor.withOpacity(isMine ? 1 : 0.1),
          isMine: isMine,
        ),
      ),
    );
  }
}

class ZIMKitMessageTrianglePainter extends CustomPainter {
  final Color color;
  final bool isMine;

  ZIMKitMessageTrianglePainter({required this.color, required this.isMine});

  @override
  void paint(Canvas canvas, Size size) {
    final paint = Paint()..color = color;

    final path = Path();
    if (isMine) {
      path.moveTo(size.width, size.height / 2);
      path.lineTo(0, 0);
      path.lineTo(0, size.height);
    } else {
      path.moveTo(0, size.height / 2);
      path.lineTo(size.width, 0);
      path.lineTo(size.width, size.height);
    }
    path.close();

    canvas.drawPath(path, paint);
  }

  @override
  bool shouldRepaint(ZIMKitMessageTrianglePainter oldDelegate) {
    return color != oldDelegate.color || isMine != oldDelegate.isMine;
  }
}
